//sounds
datablock AudioProfile(SoundDarkBowEquip)
{
   filename    = "./SND/SoundDarkBowEquip.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SoundDarkBowDraw)
{
   filename    = "./SND/SoundDarkBowDraw.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SoundDarkBowFire)
{
   filename    = "./SND/SoundDarkBowFire.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(SoundDarkBowReload)
{
   filename    = "./SND/SoundDarkBowReload.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SoundDragonArrowFlight)
{
   filename    = "./SND/SoundDragonArrowFlight.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(SoundDragonArrowExplosion)
{
   filename    = "./SND/SoundDragonArrowExplosion.wav";
   description = AudioDefault3d;
   preload = true;
};

//particles
//this is for arrowtrail
datablock ParticleData(dragonarrowTrailParticle)
{
	dragCoefficient      = 2.0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 200;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/ring";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.1 0.1 0.1 1.0";
	colors[1]     = "0.1 0.1 0.1 1.0";
	colors[2]     = "1.0 0.95 0.95 0.1";
	sizes[0]      = 1.0;
	sizes[1]      = 0.8;
	sizes[2]			= 0.1;
	times[0]      = 0.0;
	times[1]	= 0.8;
	times[2]	= 1.0;

	useInvAlpha = true;
};

//this is the muzzleflash
datablock ParticleData(darkbowRingParticle)
{
	dragCoefficient      = 0.0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 1.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/thinRing";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.0 0.4 0.0 0.7";
	colors[1]     = "0.7 0.7 0.0 0.5";
	colors[2]     = "0.0 0.0 0.0 0.1";
	sizes[0]      = 0.9;
	sizes[1]      = 0.8;
	sizes[2]			= 0.1;
	times[0]      = 0.0;
	times[1]	= 0.6;
	times[2]	= 1.0;

	useInvAlpha = false;
};

//this is the particle for the impact explosion
datablock ParticleData(DragonArrowImpactParticle)
{
	dragCoefficient      = 0.0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 200;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.0 0.0 0.0 1.0";
	colors[1]     = "1.0 1.0 0.0 0.2";
	sizes[0]      = 1.0;
	sizes[1]      = 2.0;
	times[0]      = 0.0;
	times[1]	= 1.0;

	useInvAlpha = false;
};

//finally the one for the area of effect
datablock ParticleData(darkbowFogParticle)
{
	dragCoefficient      = 2.0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 375;
	lifetimeVarianceMS   = 75;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.1 0.0 0.0 1.0";
	colors[1]     = "0.0 0.0 0.0 0.2";
	sizes[0]      = 8.0;
	sizes[1]      = 11.0;
	times[0]      = 0.0;
	times[1]	= 1.0;

	useInvAlpha = true;
};

//particlemitters
//arrow trail
datablock ParticleEmitterData(DragonArrowTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 30;
   phiReferenceVel  = 720;
   phiVariance      = 0;
   overrideAdvance = true;
   particles[0] = "dragonarrowTrailParticle";
};

//muzzle flash
datablock ParticleEmitterData(DarkBowRingEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 90.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 1;
   phiReferenceVel  = 360;
   phiVariance      = 0;
   overrideAdvance = true;
   particles[0] = "DarkBowRingParticle";
};

//impact explosion emitter
datablock ParticleEmitterData(DragonArrowImpactEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 2.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.2;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 1080;
   phiVariance      = 360;
   overrideAdvance = true;
   particles[0] = "DragonArrowImpactParticle";
};

//fog explosion emitter
datablock ParticleEmitterData(DarkBowFogEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 28.0;
   velocityVariance = 3.0;
   ejectionOffset   = 1.6;
   thetaMin         = 0;
   thetaMax         = 115;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = true;
   particles[0] = "DarkBowFogParticle";
};

//need two explosions: one for impact, one for long-term area denial
//explosions
datablock ExplosionData(DragonArrowImpactExplosion)
{
   soundProfile = SoundDragonArrowExplosion;

   delayMS = 0;
   offset = 0;
   playSpeed = 1.0;
   lifeTimeMS = 150;

   emitter[0] = "DragonArrowImpactEmitter";
   particleDensity = 3.0;
   particleRadius = 4.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 2.0 1.0";
   camShakeDuration = 2.0;
   camShakeRadius = 10.0;

   damageRadius = 5.0;
   radiusDamage = 50;

   impulseRadius = 4.0;
   impulseForce = 1000;
};

datablock ExplosionData(DarkBowFogExplosion)
{
   lifeTimeMS = 600;

   subExplosion[0]	= DragonArrowImpactExplosion;
   emitter[0] = "DarkBowFogEmitter";
   particleDensity = 14;
   particleRadius = 14.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "2.4 2.4 2.4";
   camShakeAmp = "1.2 2.4 1.2";
   camShakeDuration = 6.0;
   camShakeRadius = 16.0;

   damageRadius = 13.0;
   radiusDamage = 8;

   impulseRadius = 14.0;
   impulseForce = 24.0;
};

//projectile
AddDamageType("DarkBow",   '<bitmap:add-ons/Weapon_RuneScape/IMG/CI_darkbow> %1',    '%2 <bitmap:add-ons/Weapon_RuneScape/IMG/CI_darkbow> %1',0.5,1);

datablock ProjectileData(darkbowProjectile)
{
   projectileShapeName = "./MDL/dragonarrow.dts";

   directDamage        = 55;
   directDamageType    = $DamageType::DarkBow;
   radiusDamageType		= $DamageType::DarkBow;

   explosion             = DarkBowFogExplosion;
   particleEmitter       = DragonArrowTrailEmitter;
   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;  

   armingDelay         = 0;
   lifetime            = 3000;
   fadeDelay           = 3000;

   isBallistic         = true;  
   gravityMod = 0.35;

   hasLight    = false;

   muzzleVelocity      = 110;
   velInheritFactor    = 1;

   uiName = "Dragon Arrow";
};

//item
datablock ItemData(DarkBowItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./MDL/darkbow.dts";
	rotate = false;
	mass = 1.2;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Dark Bow";
	iconName = "./IMG/icon_darkbow";
	doColorShift = false;

	 // Dynamic properties defined by the scripts
	image = darkbowImage;
	canDrop = true;
};

datablock ShapeBaseImageData(darkbowImage)
{
   // Basic Item properties
   shapeFile = "./MDL/darkbow.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   // Projectile && Ammo.
   item = DarkBowItem;
   ammo = " ";
   projectile = darkbowProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.8;
	stateSequence[0]				= "Ready";
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= SoundDarkBowEquip;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Draw";
	stateAllowImageChange[1]         = true;

	stateName[2]					= "Draw";
	stateSequence[2]				= "Draw";
	stateWaitForTimeout[2]			= true;
	stateTimeoutValue[2]			= 1.2;
	stateSound[2]					= SoundDarkBowDraw;
	stateTransitionOnTriggerUp[2]		= "Fire";
	
	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Reset";
	stateTimeoutValue[3]            = 0.1;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]					= "onFire";
	stateWaitForTimeout[3]			= true;
	stateSound[3]					= SoundDarkBowFire;
	stateEmitter[3]					= DarkBowRingEmitter;
	stateEmitterNode[3]				= "muzzleNode";
	stateEmitterTime[3]				= 0.1;

	stateName[4]			= "Reset";
	stateAllowImageChange[4]        = true;
	stateTimeoutValue[4]            = 0.6;
	stateWaitForTimeout[4]		= true;
	stateTransitionOnTimeout[4]     = "Reload";
	
	stateName[5]			= "Reload";
	stateTimeoutValue[5]	= 0.1;
	stateTransitionOnTimeout[5]	= "Check";
	stateSequence[5]			= "Ready";
	stateSound[5]				= SoundDarkBowReload;
	stateScript[5]				= "onReload";

	stateName[6]			= "Check";
	stateTransitionOnTriggerUp[6]	= "Ready";
};

function DarkBowImage::onFire(%this,%obj,%slot)
{
	%obj.playThread(0, shiftRight);
	%obj.playThread(2, shiftLeft);
	%projectile = %this.projectile;
	%spread = 0.001;
	%shellcount = 2;
            		
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() / 500);
		%y = (getRandom() / 350);
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
}

function DarkBowImage::onReload(%this,%obj,%slot)
{
	%obj.playThread(0, shiftRight);
}