//lots of sounds
datablock AudioProfile(DLEquipSound)
{
   filename    = "./SND/DLEquipSound.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(DLSlashSound)
{
   filename    = "./SND/DLSlashSound.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(DLSwingSound)
{
   filename    = "./SND/DLSwingSound.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(DLClangSound)
{
   filename    = "./SND/DLClangSound.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(DLNoAmmoSound)
{
   filename    = "./SND/DLNoAmmoSound.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(DLBeamFireSound)
{
   filename    = "./SND/DLBeamFireSound.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(DLBeamExplosionSound)
{
   filename    = "./SND/DLBeamExplosionSound.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(DLBeamLoopSound)
{
   filename    = "./SND/DLBeamLoopSound.wav";
   description = AudioCloseLooping3d;
   preload = true;
};


//lots of particles
datablock ParticleData(DLBladeTrailParticle)
{
	dragCoefficient      = 0.0;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 1.0;
   constantAcceleration = 0;
   spinRandomMin = 0;
   spinRandomMax = 480;
   lifetimeMS           = 100;
   lifetimeVarianceMS   = 16;
   textureName          = "base/data/particles/star1";
   colors[0]     = "1.0 0.0 0.0 0.9";
   colors[1]     = "1.0 0.0 0.1 0.0";
   sizes[0]      = 0.8;
   sizes[1]      = 0.8;
   useInvAlpha = true;
};

datablock ParticleData(DLBeamTrailParticle)
{//round sport rifle-esque ring trail
	dragCoefficient      = 0.0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0;
	spinRandomMin = 0;
	spinRandomMax = 0;
	lifetimeMS           = 283;
	lifetimeVarianceMS   = 33;
	textureName          = "base/data/particles/thinRing";
	colors[0]     = "0.8 0.0 0.0 1.0";
	colors[1]     = "1.0 0.1 0.1 0.5";
	colors[2]	= "1.0 0.1 0.1 0.0";
	colors[3]	= "0.0 0.0 0.0 0.0";
	sizes[0]      = 0.4;
	sizes[1]      = 1.2;
	sizes[2]	= 0.2;
	sizes[3]	= 2.0;
	times[0]	= 0.0;
	times[1]	= 0.3;
	times[2]	= 0.9;
	times[3]	= 1.0;
};

datablock ParticleData(DLSlashParticle)
{
   dragCoefficient      = 3;
   gravityCoefficient   = -0.1;
   inheritedVelFactor   = 0;
   constantAcceleration = 0.1;
   spinRandomMin = 0;
   spinRandomMax = 15;
   lifetimeMS           = 333;
   lifetimeVarianceMS   = 50;
   textureName          = "base/data/particles/chunk";
   colors[0]     = "1.0 1.0 1.0 0.9";
   colors[1]     = "0.9 0.0 0.0 0.1";
   sizes[0]      = 0.5;
   sizes[1]      = 0.4;
};

datablock ParticleData(DLBeamExplosionParticle)
{
	dragCoefficient      = 6;
	gravityCoefficient   = -0.2;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 600;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.3 0.3 0.8";
	colors[1]     = "0.9 0.9 0.9 0.0";
	sizes[0]      = 5.0;
	sizes[1]      = 10.0;

	useInvAlpha = true;
};

datablock ParticleData(DLClangParticle)
{
   dragCoefficient      = 3;
   gravityCoefficient   = 0.9;
   inheritedVelFactor   = 0;
   constantAcceleration = 0.0;
   spinRandomMin = 0;
   spinRandomMax = 15;
   lifetimeMS           = 383;
   lifetimeVarianceMS   = 33;
   textureName          = "base/data/particles/nut";
   colors[0]     = "1.0 0.9 0.9 0.9";
   colors[1]     = "0.6 0.3 0.0 0.1";
   sizes[0]      = 0.5;
   sizes[1]      = 0.4;
};
//lots of emitters
datablock ParticleEmitterData(DLBeamTrailEmitter)
{
	ejectionPeriodMS = 5;
	ejectionVelocity = 10;
	velocityVariance = 0.0;
	ejectionOffset   = 0;
	thetaMin         = 0;
	thetaMax         = 5;
	phiReferenceVel  = 360;
	phiVariance      = 0;
	overrideAdvance = false;
	particles = "DLBeamTrailParticle";
	UIName = "D. Longsword Beam Trail";
};

datablock ParticleEmitterData(DLBladeTrailEmitter)
{//the longsword's trail - originates from tailNode
	ejectionPeriodMS = 2;
   ejectionVelocity = 30;
   velocityVariance = 0.0;
   ejectionOffset   = 0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 0;
   overrideAdvance = false;
   particles = "DLBladeTrailParticle";
   
   UIName = "D. Longsword Blade Trail";
};

datablock ParticleEmitterData(DLBeamExplosionEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 2.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DLBeamExplosionParticle";
   
   UIName = "D. Longsword Explosion";
};

datablock ParticleEmitterData(DLSlashEmitter)
{
   ejectionPeriodMS = 4;
   ejectionVelocity = 1;
   velocityVariance = 0.5;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 15;
   phiReferenceVel  = 0;
   phiVariance      = 0;
   overrideAdvance = false;
   particles = "DLslashparticle";
};

datablock ParticleEmitterData(DLClangEmitter:DLSlashEmitter)
{
	ejectionPeriodMS = 10;
	particles = "DLClangParticle";
};

//three explosions (slash, clang, beam)

datablock ExplosionData(DragonLongswordSlashExplosion)
{
   lifeTimeMS = 350;

   damageRadius = 0;
   radiusDamage = 0;

   impulseRadius = 0.1;
   impulseForce = 30;

   particleEmitter = DLSlashEmitter;
   particleDensity = 4;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "2 2 2";

   shakeCamera = true;
   camShakeFreq = "0.5 1 0.5";
   camShakeAmp = "15.0 2.0 3.0";
   camShakeDuration = 0.3;
   camShakeRadius = 0.2;

   // Dynamic light
   lightStartRadius = 1.6;
   lightEndRadius = 0;
   lightStartColor = "0.9 0.0 0.0";
   lightEndColor = "0.1 0 0";
};

datablock ExplosionData(DragonLongswordClangExplosion:DragonLongswordSlashExplosion)
{
	soundProfile = DLClangSound;
	particleEmitter = DLClangEmitter;

	lightStartRadius = 1.8;
	lightEndRadius = 0;
	lightStartColor = "0.9 0.9 0.9";
	lightEndColor = "0.1 0.1 0.5";
};

datablock ExplosionData(DragonLongswordBeamExplosion:DragonLongswordSlashExplosion)
{
	explosionShape = "./MDL/explosionSphere1.dts";
	explosionScale = "0.25 0.25 0.25";

	soundProfile = DLBeamExplosionSound;
	lifeTime = 700;

	damageRadius = 5.2;
	radiusDamage = 60;

	particleEmitter = DLBeamExplosionEmitter;
	particleDensity = 9;
	particleRadius = 4.2;

	impulseRadius = 8.0;
	impulseForce = 2400;

	shakeCamera = true;
	camShakeFreq = "4.5 1.2 7.5";
	camShakeAmp = "3.6 2.0 4.0";
	camShakeDuration = 1.3;
	camShakeRadius = 4.0;

	lightStartRadius = 3.0;
	lightEndRadius = 0;
	lightStartColor = "1.0 0.2 0.2";
	lightEndColor = "0.2 0.0 0.2";

	UiName = "D. Longsword Beam Explosion";
};

//damagetypes
AddDamageType("DragonLongswordSlash",   '<bitmap:Add-ons/Weapon_RuneScape/IMG/CI_dragonlongswordslash> %1',    '%2 <bitmap:Add-ons/Weapon_RuneScape/IMG/CI_dragonlongswordslash> %1',0.75,1);
AddDamageType("DragonLongswordBeam",   '<bitmap:Add-ons/Weapon_RuneScape/IMG/CI_dragonlongswordbeam> %1',    '%2 <bitmap:Add-ons/Weapon_RuneScape/IMG/CI_dragonlongswordbeam> %1',0.75,1);

//projectiles
//slash
datablock ProjectileData(DragonLongswordSlashProjectile)
{
   directDamage        = 35; //used in damage calculation so it can be set to zero to "shut off" the Dragon Longsword's damage.
   directDamageType  = $DamageType::DragonLongswordSlash;
   radiusDamageType  = $DamageType::DragonLongswordSlash;
   explosion           = DragonLongswordSlashExplosion;

   brickExplosionRadius = 1;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 30;
   brickExplosionMaxVolume = 2;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground
   
   muzzleVelocity      = 0;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 50;

   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   explodeOnDeath = true;
   gravityMod = 0.0;
};

//clang
datablock ProjectileData(DragonLongswordClangProjectile:DragonLongswordSlashProjectile)
{
   directDamage        = 0;
   directDamageType  = "";
   radiusDamageType  = "";
   explosion           = DragonLongswordClangExplosion;
};

//beam
datablock ProjectileData(DragonLongswordBeamProjectile)
{
   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 18;
   brickExplosionMaxVolume = 2;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 1000;
   verticalImpulse	  = 1000;

	explodeOnDeath = true;
   lifetime            = 1800;
   fadeDelay           = 1800;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0.9 0 0.2";

	sound = DLBeamLoopSound;
	directDamage = 20;
	directDamageType  = $DamageType::DragonLongswordBeam;
	radiusDamageType  = $DamageType::DragonLongswordBeam;
	projectileShapeName = "./MDL/TRANSCENDENTBLADE.dts";
	ParticleEmitter = DLBeamTrailEmitter;
	muzzleVelocity = 70;
	velInheritFactor = 0.4;

	explosion = DragonLongswordBeamExplosion;
	UIName = "D. Longsword Beam";
};

//item
datablock ItemData(DragonLongswordItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./MDL/DragonLongsword.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Dragon Longsword";
	iconName = "./IMG/Icon_dragonlongsword";
	doColorShift = true;
	colorShiftColor = "0.43 0.05 0.05 1.0";

	 // Dynamic properties defined by the scripts
	image = DragonLongswordImage;
	canDrop = true;
};

//image
datablock ShapeBaseImageData(DragonLongswordImage)
{
   // Basic Item properties
   shapeFile = "./MDL/DragonLongsword.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   correctMuzzleVector = false;

   eyeOffset = "";
   
   className = "WeaponImage";
   // Projectile && Ammo.
   item = DragonLongswordItem;
   ammo = " ";
   projectile = DragonLongswordSlashProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorshiftColor = DragonLongswordItem.colorShiftColor;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.3;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]	= DLEquipSound;

	stateName[1]                     = "Ready";
	stateTransitionOnAmmo[1]		= "BladeBeamSwitch";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.133;
	stateTransitionOnTimeout[2]     = "Swing";

	stateName[3]                    = "Swing";
	stateTransitionOnTimeout[3]     = "Check";
	stateTimeoutValue[3]            = 0.25;
	stateFire[3]                    = false;
	stateAllowImageChange[3]        = false;
	stateScript[3]                  = "onSwing";
	stateWaitForTimeout[3]		= true;

	stateName[4]                    = "Check";
	stateTransitionOnTimeout[4]     = "Ready";
	stateTimeoutValue[4]            = 0.15;
	stateAllowImageChange[4]        = false;
	stateWaitForTimeout[4]		= true;
	stateScript[4]                  = "onStopFire";
	
	stateName[5] = "BladeBeamSwitch"; //will check other variables to see if we can shoot the blade beam.
	stateWaitForTimeout[5]	= true;
	stateTimeoutValue[5]	= 0.1; //don't spam
	stateScript[5]	= "onBladeBeamSwitch";
	stateTransitionOnTimeout[5]	= "BladeBeamAmmoCheck";
	
	stateName[6]	= "BladeBeamAmmoCheck";
	stateTransitionOnAmmo[6] = "BladeBeamAttack";
	stateTransitionOnNoAmmo[6]	= "Ready";
	
	//blade beam swing goes here.
	stateName[7] = "BladeBeamAttack";
	stateEmitter[7] = DLBladeTrailEmitter;
	stateEmitterNode[7]	= "tailNode";
	stateEmitterTime[7]	= 0.4;
	stateTimeoutValue[7] = 0.4;
	stateScript[7]	= "onBladeBeamAttack";
	stateTransitionOnTimeout[7] = "Check";
	
};

function DragonLongswordImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.setImageAmmo(0,0); //we are not in blade-beam mode.
	if(!%obj.DLBladeBeamTime)//your first equip of this weapon
	{
		%obj.DLAmmo = 2; //maximum two blade beams at a time over 10 seconds.
		%obj.DLBladeBeamTime = getSimTime();
	}
}

function DragonLongswordImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, activate);
	%obj.playThread(0,jump);
	%obj.playedHitSound = 0; //slice sound plays one time maximum - does not affect clang.
}

function DragonLongswordImage::onSwing(%this, %obj, %slot)
{
	%obj.playThread(0, shiftDown);
	%obj.playThread(2, shiftDown);
	serverPlay3d(DLSwingSound,%obj.getPosition());
	
	%limit = 5;
	schedule(16,%this,DragonLongswordAttack,%this,%obj,%slot,%limit); //schedule so the animation works a bit better.	
}

function DragonLongswordAttack(%this,%obj,%slot,%limit)
{
	%start = %obj.getEyePoint();
    %aimVec = getEyeAimVector(%obj); //function in server.cs
	
	//SWING ARC CALCULATION
	%scale = getWord(%obj.getScale(),2); //Y PlayerScale.
	
	switch(%limit != 777)
	{
		case 1:
			%angle = mDegtoRad(205 - (18.75*(%limit-1))); //range: 130 to 205 degrees (75 deg) of swing, 5 iterations.
		default:
			%angle = mDegtoRad(180); //straight hit for our limit of 777.
	}
	//Angle is changed to radians. For the y-vector, we take the cosine, and the sine for z.
	%offset = 3.5*%scale; //the range times player size (y-axis)
	//this is from Gytyygfhty- that guy. 
	%right = vectorNormalize(vectorCross(%aimVec, "0 0 1"));
	%vert = vectorCross(%aimVec, %right);
	%horz = vectorNormalize(%aimVec);
	%horzOffset = -mCos(%angle)*%offset;
	%vertOffset = -mSin(%angle)*%offset;
	%rightOffset = getRandom(-0.1,0.1); //x shakes side to side
	%displacement = vectorNormalize(vectorAdd(%aimVec, vectorAdd(vectorScale(%right,%rightOffset),vectorAdd(vectorScale(%horz,%horzOffset),vectorScale(%vert,%vertOffset))))); 
	
	%center = vectorAdd(vectorScale(%obj.getVelocity(),(1/60)),vectorAdd(%start,vectorScale(%displacement,(%offset)))); //%obj.getVelocity so start position is adjusted for player speed for one frame of movement

	//targets - we hit these; those not included in %ptargets below will clang.
	%targets =  $TypeMasks::FXBrickObjectType |    //Bricks
				$TypeMasks::PlayerObjectType | 
				$TypeMask::VehicleObjectType |
				$TypeMasks::StaticObjectType |    //Static Shapes
				$TypeMasks::TerrainObjectType;    //Terrain
	//ptargets = we damage these targets			
	%ptargets = $TypeMasks::PlayerObjectType |
				$TypeMask::VehicleObjectType;

	%hitting = 1;
	%ray = ContainerRayCast(%start, %center, %targets, %obj);
	%body = getWord(%ray,0);
	if(isObject(%body) && %body != %obj && (%col=%body.getType()) & %targets)
	{
		%didHit = 1; //for proper 777 calc so you can't shoot that shit through walls
		%surface = posFromRaycast(%ray); //surface of victim
		%inertia = normalFromRaycast(%ray); //movement of victim
		if(%col & %ptargets) //if the object hit is one of the objects we can penetrate
		{	
			%projectile = DragonLongswordSlashProjectile;
			if(%obj.playedHitSound == 0)
			{
				%obj.playedHitSound = 1;
				serverPlay3d(DLSlashSound,%surface);
			}
			DragonLongswordImage::onHitObject(%this,%obj,%slot,%limit,%body,%surface,%aimVec);
		}
		else
		{
			%projectile = DragonLongswordClangProjectile;
			switch(%limit>1)//last hit immune to clang.
			{
				case 1:
					%hitting = 0;
				default:
					%hitting = 1;
			}
		}
		%p = new (%this.projectileType)() //eliminated redundancy by putting it here and having the booleans define %projectile.
		{
			dataBlock = %projectile;
			initialVelocity = %inertia;
			initialPosition = %surface;
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
		%p.setScale(%scale SPC %scale SPC %scale);
	}
	
	switch(%didHit)
	{
		case 1:
			%placement = %surface; //so your beam doesn't phase thru walls
		default:
			%placement = %center;
	}
	
	switch(%limit != 777)
	{
		case 1:
			%limit--;
			DragonLongswordHitboxes(%this,%obj,%slot,%limit,%hitting); //1 for slash 0 for clang
		default:
			return %placement;
	}
}

function DragonLongswordHitboxes(%this,%obj,%slot,%limit,%goodHits) //checks before we re-do DragonLongswordAttack, and is called by DragonLongswordAttack in recursion
{
	if(%limit > 0 && %goodhits == 1)
	{
		schedule(16,%this,DragonLongswordAttack,%this,%obj,%slot,%limit);
	}
	else
	{
		if(%goodhits == 0)
		{
			%limit = 0;
			%obj.playThread(0,activate);
			%obj.playThread(2,activate);
		}
	}	
}


function DragonLongswordImage::onStopFire(%this, %obj, %slot)
{
	%obj.setImageAmmo(0,0); //just as a safeguard if you right-clicked during the swing.
}

function DragonLongswordImage::onHitObject(%this,%obj,%slot,%limit,%target,%pos,%aimVec)
{
	if(!isObject(%target))
	{
		return; //it's good practice to do this
	}
	
	if(%this.projectile.DirectDamage > 0)
   {
      if(isObject(%target.spawnBrick) && %target.spawnBrick.getGroup().client == %obj.client) //if they're in our minigame
         %dmg = 1;
      if(miniGameCanDamage(%obj,%target) == 1 || %dmg)
         %dmg = 1;
   }
   
   if(%dmg == 1)
   {
		%damageType = %this.projectile.DirectDamageType;
		%scale = getWord(%obj.getScale(),2);
		
		%dam = %this.projectile.directDamage;
		
		switch(%limit != 777) //if limit is not equal to 6
		{
			case 1:
				%dcalc = %dam - %dam*(6*mAbs(%limit-3)/35); //hit number 3 does the most damage.
			default:
				%limit = 3; //for the knockback hit below -  i still don't think it actually works
				%dcalc = %dam*1.5; //limit of 777 - biig ol hit
		}
		%directDamage = mClampF(%dcalc,-100,100)*%scale;
		
		%target.damage(%obj, %pos, %directDamage, %damageType);
		
		if(%limit >= 3)
		{
			%d = (3/%limit);
			%target.applyImpulse(%pos,vectorScale(%aimVec,300*%d));
			%target.applyImpulse(%pos,VectorScale("0 0 1",200*%d));
		}
		return 1;
   }
   return 0;
}

package DragonLongswordAltFire //uses the state machine, will let us fire a blade-beam
{
   function Armor::onTrigger(%this, %player, %slot, %val)
   {
	if(%player) //just an extra safeguard
	{
		if(%player.getMountedImage(0) $= DragonLongswordImage.getID() && %slot $= 4 && %val)
			%player.setImageAmmo(0,1); //set to (0,0) by default.
	}
	return Parent::onTrigger(%this, %player, %slot, %val);
   }
};   
ActivatePackage(DragonLongswordAltFire);

function DragonLongswordImage::onBladeBeamSwitch(%this,%obj,%slot)
{
	%difference = mAbs(getSimTime() - %obj.dlBladeBeamTime);
	%ammocalc = mClampF(%obj.dlAmmo+(%difference/7000),0,2); //14 seconds to get a full recharge of two shots from 0
	%obj.dlAmmo = %ammocalc; //reloads a bit every time you right-click.
	%obj.dlBladeBeamTime = getSimTime();
	
	if(%ammocalc > 1)
	{
		%obj.playThread(0,rotCW);
		%obj.playThread(2,activate);
		%obj.schedule(66,playThread,0,plant);
		%obj.schedule(66,playThread,2,shiftDown);
		schedule(66,%obj,serverPlay3d,DLBeamFireSound,%obj.getPosition());
		%obj.schedule(100,playThread,2,wrenchHit);
		%obj.schedule(83,playThread,0,wrenchHit);
		
		%obj.setImageAmmo(%slot,1); //we're good to go
	}
	else
	{
		%obj.setImageAmmo(%slot,0);
		serverPlay3d(DLNoAmmoSound,%obj.getPosition());
		%obj.playThread(0,plant);
		%obj.playThread(2,undo); //smh
	}
}

function DragonLongswordImage::onBladeBeamAttack(%this,%obj,%slot)
{//occurs right after imageammo was set to 1 in onbladebeamswitch.
	%obj.setImageAmmo(%slot,0);
	if(%obj.dlAmmo < 1)
	{
		serverPlay3d(DLNoAmmoSound,%obj.getPosition());
		%obj.playThread(0,plant);
		%obj.playThread(2,undo); //smh
		return; //to make sure you can't fire this without enough ammo. It could happen if you spam RMB enough.
	}

	%limit = 777; //SPECIAL limit of 777!
	%centre = DragonLongswordAttack(%this,%obj,%slot,%limit); //will return %center or %surface when %limit = 777.

	%obj.dlAmmo = mClampF((%obj.dlAmmo-1.2),0,2);
	%projectile = DragonLongswordBeamProjectile;
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = vectorScale(getEyeAimVector(%obj),%projectile.muzzleVelocity);
		initialPosition = %centre;
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	%scale = getWord(%obj.getScale(),2);
	%p.setScale(%scale SPC %scale SPC %scale);
}