//sound
datablock AudioProfile(SoundStaffEquip)
{
	fileName = "./SND/SoundStaffEquip.wav";
	preload = true;
	description = AudioClose3D;
};

datablock AudioProfile(SoundStaffFire)
{
	fileName = "./SND/SoundStaffFire.wav";
	preload = true;
	description = AudioDefault3D;
};

datablock AudioProfile(SoundStaffCharge)
{
	fileName = "./SND/SoundStaffCharge.wav";
	preload = true;
	description = AudioClose3D;
};

datablock AudioProfile(SoundStaffBash)
{
	fileName = "./SND/SoundStaffBash.wav";
	preload = true;
	description = AudioClose3D;
};

datablock AudioProfile(SoundSkullFlight)
{
	fileName = "./SND/SoundSkullFlight.wav";
	preload = true;
	description = AudioDefaultLooping3D;
};

datablock AudioProfile(SoundSkullExplosion)
{
	fileName = "./SND/SoundSkullExplosion.wav";
	preload = true;
	description = AudioDefault3D;
};

//Particle

datablock ParticleData(IbanAmbientParticle)
{
	dragCoefficient      = 0.0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 150;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.0 0.0 0.0 1.0";
	colors[1]     = "1.0 0.0 0.0 0.9";
	colors[2]     = "1.0 0.0 0.1 0.1";
	sizes[0]      = 0.1;
	sizes[1]      = 0.1;
	sizes[2]			= 0.1;
	times[0]      = 0.0;
	times[1]	= 0.8;
	times[2]	= 1.0;

	useInvAlpha = false;
};



datablock ParticleData(IbanFlashParticle)
{
	dragCoefficient      = 0.0;
	gravityCoefficient   = 1.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 233;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.0 0.3 0.0 1.0";
	colors[1]     = "1.0 0.5 0.0 0.4";
	colors[2]     = "1.0 1.0 0.0 0.1";
	sizes[0]      = 3.0;
	sizes[1]      = 1.8;
	sizes[2]			= 0.1;
	times[0]      = 0.0;
	times[1]	= 0.6;
	times[2]	= 1.0;

	useInvAlpha = false;
};

datablock ParticleData(IbanFlightParticle)
{
	dragCoefficient      = 0.4;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.75;
	constantAcceleration = 0.0;
	lifetimeMS           = 150;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.0 0.3 0.0 0.8";
	colors[1]     = "1.0 0.5 0.0 0.6";
	colors[2]     = "1.0 1.0 0.0 0.1";
	sizes[0]      = 1.2;
	sizes[1]      = 0.5;
	sizes[2]			= 0.1;
	times[0]      = 0.0;
	times[1]	= 0.9;
	times[2]	= 1.0;

	useInvAlpha = false;
};

datablock ParticleData(IbanBlastClumpParticle)
{
	dragCoefficient      = 1.0;
	gravityCoefficient   = -0.3;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.4;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.8 0.3 0.0 0.9";
	colors[1]     = "1.0 0.0 0.0 0.3";
	sizes[0]      = 1.8;
	sizes[1]      = 3.0;
	times[0]      = 0.0;
	times[1]	= 1.0;

	useInvAlpha = false;
};

datablock ParticleData(IbanBlastStarParticle)
{
	dragCoefficient      = 0.0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 200;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.0 0.3 0.0 0.6";
	colors[1]     = "0.4 0.0 0.0 0.8";
	colors[2]     = "0.8 0.0 0.5 0.1";
	sizes[0]      = 0.6;
	sizes[1]      = 1.0;
	sizes[2]			= 2.4;
	times[0]      = 0.0;
	times[1]	= 0.5;
	times[2]	= 1.0;

	useInvAlpha = true;
};

datablock ParticleData(IbanBlastNuclearParticle)
{
	dragCoefficient      = 0.0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 600;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.0 0.0 0.0 0.0";
	colors[1]     = "1.0 0.0 0.0 0.05";
	colors[2]     = "1.0 0.5 0.0 1.0";
	sizes[0]      = 3.2;
	sizes[1]      = 0.3;
	sizes[2]			= 0.12;
	times[0]      = 0.0;
	times[1]	= 0.95;
	times[2]	= 1.0;

	useInvAlpha = false;
};

datablock ParticleData(IbanBlastChunkParticle)
{
	dragCoefficient      = 0.6;
	gravityCoefficient   = 1.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 150;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/chunk";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.3 0.1 0.0 0.8";
	colors[1]     = "0.1 0.0 0.0 0.2";
	sizes[0]      = 2.4;
	sizes[1]      = 0.4;
	times[0]      = 0.0;
	times[1]	= 1.0;

	useInvAlpha = false;
};

//emitter

datablock ParticleEmitterData(IbanAmbientEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 0.0;
   ejectionOffset   = 0.6;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 180;
   phiVariance      = 90;
   overrideAdvance = true;
   particles[0] = "IbanAmbientParticle";
};

// datablock ParticleEmitterData(IbanAgitatedEmitter)
// {
   // ejectionPeriodMS = 3;
   // periodVarianceMS = 0;
   // ejectionVelocity = 5;
   // velocityVariance = 2.0;
   // ejectionOffset   = 0.5;
   // thetaMin         = 90;
   // thetaMax         = 180;
   // phiReferenceVel  = 360;
   // phiVariance      = 90;
   // overrideAdvance = true;
   // particles[0] = "IbanAmbientParticle";
// };

datablock ParticleEmitterData(IbanFlashEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 3.2;
   velocityVariance = 0.8;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 180;
   phiVariance      = 180;
   overrideAdvance = true;
   particles[0] = "IbanFlashParticle";
};

datablock ParticleEmitterData(IbanFlightEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 30;
   phiReferenceVel  = 60;
   phiVariance      = 180;
   overrideAdvance = true;
   particles[0] = "IbanFlightParticle";
};

datablock ParticleEmitterData(IbanBlastClumpEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 14;
   velocityVariance = 0;
   ejectionOffset   = 0.2;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 360;
   phiVariance      = 360;
   overrideAdvance = true;
   particles[0] = "IbanBlastClumpParticle";
};

datablock ParticleEmitterData(IbanBlastStarEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 2.0;
   velocityVariance = 0.0;
   ejectionOffset   = 4.2;
   thetaMin         = 80;
   thetaMax         = 90;
   phiReferenceVel  = 360;
   phiVariance      = 360;
   overrideAdvance = true;
   particles[0] = "IbanBlastStarParticle";
};

datablock ParticleEmitterData(IbanBlastNuclearEmitter)
{
   ejectionPeriodMS = 6;
   periodVarianceMS = 0;
   ejectionVelocity = 0.2;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 360;
   phiVariance      = 360;
   overrideAdvance = true;
   particles[0] = "IbanBlastNuclearParticle";
};

datablock ParticleEmitterData(IbanBlastChunkEmitter)
{
   ejectionPeriodMS = 8;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 0;
   ejectionOffset   = 0.0;
   thetaMin         = 75;
   thetaMax         = 105;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = true;
   particles[0] = "IbanBlastChunkParticle";
};


//explosion

datablock ExplosionData(IbanBlastExplosion)
{
   soundProfile = SoundSkullExplosion;

   lifeTimeMS = 300;

   emitter[0] = "IbanBlastStarEmitter";
   emitter[1] = "IbanBlastClumpEmitter";
   particleDensity = 12;
   particleRadius = 8.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 2.0 1.0";
   camShakeDuration = 2.0;
   camShakeRadius = 10.0;

   damageRadius = 9.0;
   radiusDamage = 45;

   impulseRadius = 8.0;
   impulseForce = 1250;
};

datablock ExplosionData(IbanBashExplosion)
{
   soundProfile = SoundStaffBash;

   lifeTimeMS = 125;

   emitter[0] = "IbanBlastChunkEmitter";
   particleDensity = 2.0;
   particleRadius = 3.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 2.0 1.0";
   camShakeDuration = 2.4;
   camShakeRadius = 6.0;

   damageRadius = 1.0;
   radiusDamage = 1;

   impulseRadius = 1.0;
   impulseForce = 100;
};

//ambient iban image
datablock ShapeBaseImageData(IbanIdleImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;
   armReady = false;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = IbanStaffItem;
   
	stateName[0]	= "Activate";
	stateTimeoutValue[0]	= 0.8;
	stateTransitionOnTimeout[0]	= "Ready";
	
	stateName[1]	= "Ready";
	stateEmitter[1]				= IbanAmbientEmitter;
	stateEmitterNode[1]			= "muzzleNode";
	stateEmitterTime[1]			= 0.2;
	stateWaitForTimeout[1]		= false;
	stateTransitionOnTimeout[1]	= "Ready";
	// stateTransitionOnTriggerDown[1] = "Charging"; //when Charge is activated on the main image. //I couldn't get this stupid shit to work.
	stateTimeoutValue[1]		= 0.2;
	
	// stateName[2] = "Charging";
	// stateEmitter[2] = IbanAgitatedEmitter;
	// stateEmitterNode[2] = "muzzleNode";
	// stateEmitterTime[2] = 0.7;
	// stateTimeoutValue[2]	= 0.8;
	// stateTransitionOnTimeout[2] = "BlastOff";
	
	// stateName[3] = "BlastOff";
	// stateEmitter[3] = IbanFlashEmitter;
	// stateEmitterTime[3] = 0.083;
	// stateEmitterNode[3] = "muzzleNode";
	// stateScript[3] = "onBlastOff";
	// stateTimeoutValue[3] = 0.12;
	// stateTransitionTimeout[3] = "Ready";
};

//Iban Blast
AddDamageType("IbanBlast", '<bitmap:add-ons/Weapon_RuneScape/IMG/CI_ibanblast> %1', '%2 <bitmap:add-ons/Weapon_RuneScape/IMG/CI_ibanblast> %1',0.2,1); 
datablock ProjectileData(IbanBlastProjectile : gunProjectile)
{
	ProjectileShapeName = "./MDL/blastskull.dts";
	directDamage = 60;
	directDamageType    = $DamageType::IbanBlast;
	radiusDamageType    = $DamageType::IbanBlast;

	particleEmitter = IbanFlightEmitter;

	impactImpulse = 400;
	verticalImpulse = 900;
	velInheritFactor  = 1.0;

	isBallistic	= false;
	gravityMod	= 0.4;
	armingDelay	= 0;
	lifetime	= 850;

	muzzleVelocity	= 180;
	bounceElasticity	= 0.0;
	explodeOnDeath		= true;

	explosion = IbanBlastExplosion;
	sound = SoundSkullFlight;
};

//IBAN BASH
AddDamageType("IbanBash", '<bitmap:add-ons/Weapon_RuneScape/IMG/CI_staffofiban> %1', '%2 <bitmap:add-ons/Weapon_RuneScape/IMG/CI_staffofiban> %1',0.2,1); 
datablock ProjectileData(IbanBashProjectile : gunProjectile)
{
	ProjectileShapeName = "base/data/shapes/empty.dts";
	directDamage = 38;
	directDamageType    = $DamageType::IbanBash;
	radiusDamageType    = $DamageType::IbanBash;

	impactImpulse = 1300; //good for pushing people back
	verticalImpulse = 500;
	velInheritFactor  = 1.0;

	armingDelay	= 0;
	lifetime	= 75;

	muzzleVelocity	= 150;
	bounceElasticity	= 0.0;
	explodeOnDeath		= false;

	explosion = IbanBashExplosion;
};

datablock ItemData(IbanStaffItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./MDL/IbanStaff2.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Staff of Iban";
  	iconName = "./IMG/icon_staffofiban";
	doColorShift = false;

	 // Dynamic properties defined by the scripts
	image = IbanStaffImage;
	canDrop = true;
};

datablock ShapeBaseImageData(IbanStaffImage)
{
   // Basic Item properties
   shapeFile = IbanStaffItem.shapeFile;
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = IbanStaffItem;
   ammo = " ";
   projectile = IbanBlastProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;

   //casing = " ";

	stateName[0]	= "Activate";
	stateSound[0]	= SoundStaffEquip;
	stateWaitForTimeout[0]	= true;
	stateTimeoutValue[0]	= 0.8;
	stateTransitionOnTimeout[0]	= "Ready";

	stateName[1]	= "Ready";
	stateAllowImageChange[1]	= true;
	stateTransitionOnTriggerDown[1]	= "Choice";
	
	stateName[2]	= "Choice";
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTimeout[2]	= "Charge";
	stateTimeoutValue[2]		= 0.15;
	stateTransitionOnTriggerUp[2]	= "Bash";
	
	stateName[3]	= "Charge";
	stateEmitter[3] = IbanBlastNuclearEmitter;
	stateEmitterTime[3]	= 0.9;
	stateEmitterNode[3]	= "muzzleNode";
	stateTimeoutValue[3]	= 0.9;
	stateScript[3]	= "onCharge";
	stateSound[3]	= SoundStaffCharge;
	stateTransitionOnTimeout[3]	 = "Fire";
	
	stateName[4] = "Fire";
	stateScript[4] = "onFire";
	stateEmitter[4] = IbanFlashEmitter;
	stateEmitterTime[4]	= 0.15;
	stateEmitterNode[4]	= "muzzleNode";
	stateTimeoutValue[4]	= 0.15;
	stateFire[4]	= true;
	stateSound[4]	= SoundStaffFire;
	stateTransitionOnTimeout[4] = "Reset";
	
	stateName[5]	= "Bash";
	stateScript[5]	= "onBash";
	stateWaitForTimeout[5]		= true;
	stateTimeoutValue[5]	= 0.20;
	stateTransitionOnTimeout[5]	= "Reset";
	
	stateName[6]	= "Reset";
	stateTransitionOnTriggerUp[6] = "Ready";
};

function IbanStaffImage::onMount(%this, %obj, %slot)
{
	%obj.mountImage(IbanIdleImage, 1);
	Parent::onMount(%this,%obj,%slot);
}

function IbanStaffImage::onUnMount(%this, %obj, %slot)
{
	Parent::onUnMount(%this,%obj,%slot);
	%obj.setarmthread(look);
	%obj.unmountImage(1);
}

function IbanStaffImage::onCharge(%this,%obj,%slot)
{
	%obj.playThread(0, shiftRight);
	%obj.playThread(2, shiftLeft);
	%obj.schedule(400, playThread, 2, armReadyBoth);
	%obj.schedule(500, setArmThread, activate2);
}

function IbanStaffImage::onFire(%this,%obj,%slot) //fires from the eye
{
	%obj.playThread(0,shiftDown);
	%obj.playThread(2,shiftDown);
	%obj.schedule(0, setArmThread, look);
	
	%projectile = %this.Projectile;
    %vector = getEyeAimVector(%obj); //see server.cs for this function
	%objectVelocity = %obj.getVelocity();
    %vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
    %vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
    %velocity = VectorAdd(%vector1,%vector2);
	%p = new Projectile()
		{
            dataBlock = %projectile;
            initialVelocity = %velocity;
            initialPosition = %obj.getMuzzlePoint(%slot); //eyeAim vector, muzzle origin. may be janky!
            sourceObject = %obj;
            sourceSlot = %slot;
            client = %obj.client;
         };
	MissionCleanup.add(%p);
	return %p;
	// schedule(50, trace, 0);
}

function IbanStaffImage::onBash(%this,%obj,%slot)
{
	%obj.playThread(0, armAttack);
	%obj.schedule(200, stopThread, 0);
	
	%projectile = IbanBashProjectile;
    %vector = getEyeAimVector(%obj);
	%objectVelocity = %obj.getVelocity();
    %vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
    %vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
    %velocity = VectorAdd(%vector1,%vector2);
	%p = new Projectile()
		{
            dataBlock = %projectile;
            initialVelocity = %velocity;
            initialPosition = %obj.getEyePoint(); //attack will generate from here
            sourceObject = %obj;
            sourceSlot = %slot;
            client = %obj.client;
         };
    MissionCleanup.add(%p);
    return %p;
}